/* TCP/IP scaner. ॡࠥ ping'   㪠  */
/*  뤠  stdout   䠩, ᫨  ,  ⮧*/ 
/* ⮢                                                         */
/* 맮: ipscan <subnetaddr> [filename]                          */

/* 砥 㭪 FtpPing  rxftp.dll */
call RxFuncAdd FtpLoadFuncs, rxFtp, FtpLoadFuncs
call FtpLoadFuncs FtpPing

/* 砥  ࠬ  . ப  १   譨 ஡
*/
parse arg subnet fileName
subnet=STRIP(subnet)

/* ஢塞 稥 室 ࠬ஢ */
if subnet = '' then do
    say 'USAGE: ipscan <subnetaddr> [file name]'
    say '       subnetaddr - class C subnet address' 
    exit
end

addr = 0

/* ॡࠥ        C */
do 254

    addr=addr+1

    /* ନ㥬  ।  */
    hostName=subnet'.'addr

    /* 㥬  */
    rc = FtpPing( hostName, 56 ) 

    /* ᫨ ந諠 訡, 뤠 ᮮ饭  뢠 */
    select
        when rc = PINGSOCKET then do
            say 'ERROR: Unable to obtain socket'
            exit
        end

        when rc = PINGPROTO then do
            say 'ERROR: Unknown protocol ICMP'
            exit
        end

        when rc = PINGSEND then do
            say 'ERROR: Send failed'
            exit
        end

        when rc = PINGRECV then do
            say 'ERROR: Receive failed'
            exit
        end

        when rc = PINGHOST then do
            say 'ERROR: Unknown host'
            exit
        end

        /* ᫨  ⮧, 襬    stdout */
        when rc <> PINGREPLY then do
            say hostName
            if (fileName <> '') then rc=lineout( fileName, hostName )
        end

        otherwise

    end  /* select */

end  /* do */

/* 㦠 FTP API */
FtpDropFuncs()

